# coding: utf-8

"""
    Agilicus API

    Agilicus API endpoints  # noqa: E501

    The version of the OpenAPI document: 2021.02.02
    Contact: dev@agilicus.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from agilicus_api.configuration import Configuration


class ResourcePermissionSpec(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'user_id': 'str',
        'org_id': 'str',
        'resource_id': 'str',
        'resource_type': 'str',
        'resource_role_name': 'str'
    }

    attribute_map = {
        'user_id': 'user_id',
        'org_id': 'org_id',
        'resource_id': 'resource_id',
        'resource_type': 'resource_type',
        'resource_role_name': 'resource_role_name'
    }

    def __init__(self, user_id=None, org_id=None, resource_id=None, resource_type=None, resource_role_name=None, local_vars_configuration=None):  # noqa: E501
        """ResourcePermissionSpec - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._user_id = None
        self._org_id = None
        self._resource_id = None
        self._resource_type = None
        self._resource_role_name = None
        self.discriminator = None

        self.user_id = user_id
        self.org_id = org_id
        self.resource_id = resource_id
        self.resource_type = resource_type
        self.resource_role_name = resource_role_name

    @property
    def user_id(self):
        """Gets the user_id of this ResourcePermissionSpec.  # noqa: E501

        The unique id of the user which has this permission.  # noqa: E501

        :return: The user_id of this ResourcePermissionSpec.  # noqa: E501
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """Sets the user_id of this ResourcePermissionSpec.

        The unique id of the user which has this permission.  # noqa: E501

        :param user_id: The user_id of this ResourcePermissionSpec.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and user_id is None:  # noqa: E501
            raise ValueError("Invalid value for `user_id`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                user_id is not None and len(user_id) > 40):
            raise ValueError("Invalid value for `user_id`, length must be less than or equal to `40`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                user_id is not None and len(user_id) < 1):
            raise ValueError("Invalid value for `user_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._user_id = user_id

    @property
    def org_id(self):
        """Gets the org_id of this ResourcePermissionSpec.  # noqa: E501

        The unique id of the Organisation which the user must be logged in to in order to access the resource with this permission.   # noqa: E501

        :return: The org_id of this ResourcePermissionSpec.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this ResourcePermissionSpec.

        The unique id of the Organisation which the user must be logged in to in order to access the resource with this permission.   # noqa: E501

        :param org_id: The org_id of this ResourcePermissionSpec.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and org_id is None:  # noqa: E501
            raise ValueError("Invalid value for `org_id`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                org_id is not None and len(org_id) > 40):
            raise ValueError("Invalid value for `org_id`, length must be less than or equal to `40`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                org_id is not None and len(org_id) < 1):
            raise ValueError("Invalid value for `org_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._org_id = org_id

    @property
    def resource_id(self):
        """Gets the resource_id of this ResourcePermissionSpec.  # noqa: E501

        The unique id of the resource to which the user is granted access.  # noqa: E501

        :return: The resource_id of this ResourcePermissionSpec.  # noqa: E501
        :rtype: str
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id):
        """Sets the resource_id of this ResourcePermissionSpec.

        The unique id of the resource to which the user is granted access.  # noqa: E501

        :param resource_id: The resource_id of this ResourcePermissionSpec.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and resource_id is None:  # noqa: E501
            raise ValueError("Invalid value for `resource_id`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                resource_id is not None and len(resource_id) > 100):
            raise ValueError("Invalid value for `resource_id`, length must be less than or equal to `100`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                resource_id is not None and len(resource_id) < 1):
            raise ValueError("Invalid value for `resource_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._resource_id = resource_id

    @property
    def resource_type(self):
        """Gets the resource_type of this ResourcePermissionSpec.  # noqa: E501

        The type of the resource referred to by `resource_id`.  # noqa: E501

        :return: The resource_type of this ResourcePermissionSpec.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this ResourcePermissionSpec.

        The type of the resource referred to by `resource_id`.  # noqa: E501

        :param resource_type: The resource_type of this ResourcePermissionSpec.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and resource_type is None:  # noqa: E501
            raise ValueError("Invalid value for `resource_type`, must not be `None`")  # noqa: E501
        allowed_values = ["fileshare"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and resource_type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `resource_type` ({0}), must be one of {1}"  # noqa: E501
                .format(resource_type, allowed_values)
            )

        self._resource_type = resource_type

    @property
    def resource_role_name(self):
        """Gets the resource_role_name of this ResourcePermissionSpec.  # noqa: E501

        The unique id of the role assigned to the user.  # noqa: E501

        :return: The resource_role_name of this ResourcePermissionSpec.  # noqa: E501
        :rtype: str
        """
        return self._resource_role_name

    @resource_role_name.setter
    def resource_role_name(self, resource_role_name):
        """Sets the resource_role_name of this ResourcePermissionSpec.

        The unique id of the role assigned to the user.  # noqa: E501

        :param resource_role_name: The resource_role_name of this ResourcePermissionSpec.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and resource_role_name is None:  # noqa: E501
            raise ValueError("Invalid value for `resource_role_name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                resource_role_name is not None and len(resource_role_name) > 40):
            raise ValueError("Invalid value for `resource_role_name`, length must be less than or equal to `40`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                resource_role_name is not None and len(resource_role_name) < 1):
            raise ValueError("Invalid value for `resource_role_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._resource_role_name = resource_role_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourcePermissionSpec):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ResourcePermissionSpec):
            return True

        return self.to_dict() != other.to_dict()
